using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.Net.Mail;
using System.IO;
using System.Windows.Forms;
using System.Text.RegularExpressions;



namespace WindowsFormsApplication1
{
    class MailHandler
    {
        string SMTP_server;
        string SMTP_user;
        string SMTP_pass;
        string POP_server;
        string POP_user;
        string POP_pass;

        // Set SMTP Server Details (Host , User, & Password)
        public void SetSMTP(string server, string user, string pass)
        {
            SMTP_server = server;
            SMTP_user = user;
            SMTP_pass = pass;
        }

        // Set POP3 Server Details (Host , User, & Password)
        public void SetPOP(string server, string user, string pass)
        {
            POP_server = server;
            POP_user = user;
            POP_pass = pass;
        }


        /*
         * socketReadLine
         * 
         * This is a sub function the Retrive Mail function is using
         * in oreder to commuinicate with the mail server and retrive the replayied data.
         * 
         */
        public String socketReadLine(Socket socket,String terminator)
        {
            int lastRead=0;
            String streamData = "";
            NetworkStream networkStream = new NetworkStream(socket);
            do
            {
                lastRead = networkStream.ReadByte();
                if (lastRead == -1) break;
                streamData += (Convert.ToChar(lastRead));
                if (streamData.EndsWith(terminator)) break;
            }
            while (true);
            return streamData;
        }


        /*
         * Send POP3 Commands.
         * This is a sub function the SendMail function is using
         * in oreder to commuinicate with the mail server.
         * 
         */ 
        public string sendPOP3cmd(string cmd, NetworkStream NetStrm, TextBox tbStatus)
        {
            byte[] szData;
            string returnedData = "";
            StreamReader RdStrm = new StreamReader(NetStrm);
            szData =
            System.Text.Encoding.ASCII.GetBytes(cmd.ToCharArray());
            NetStrm.Write(szData, 0, szData.Length);
            returnedData = RdStrm.ReadLine();
            tbStatus.Text += cmd + "\r\n" + returnedData + "\r\n";
            return returnedData;
        }


        /*
         * 
         * Retrievs The number of email on the server.
         * tbStatus - txtBox To Display Communication with the host.
         * KeepMsgOnServer - when 'true' will not delete the msg from the server.
         * pBar - Display the progress bar of the emails retrieving action. 
         * 
         */
        public int RetrieveMailCount(TextBox tbStatus, bool KeepMsgOnServer, ProgressBar pBar)
        {
            tbStatus.Text = "";
            TcpClient clientSocket = new TcpClient(POP_server, 110);
            NetworkStream NetStrm = clientSocket.GetStream();

            StreamReader RdStrm = new StreamReader(NetStrm);
            tbStatus.Text += RdStrm.ReadLine();
            sendPOP3cmd("USER " + POP_user + "\r\n", NetStrm, tbStatus);
            sendPOP3cmd("PASS " + POP_pass + "\r\n", NetStrm, tbStatus);
            string Data = sendPOP3cmd("STAT\r\n", NetStrm, tbStatus);
            string[] BreakDown = Data.Split(" ".ToCharArray());
            int messageCount = Convert.ToInt16(BreakDown[1]);
            sendPOP3cmd("QUIT\r\n", NetStrm, tbStatus);
            clientSocket.Close();
            return messageCount;
        }





        /*
         * 
         * Retrievs All Mails On the Server - Requiers the POP setting !!
         * tbStatus - txtBox To Display Communication with the host.
         * KeepMsgOnServer - when 'true' will not delete the msg from the server.
         * pBar - Display the progress bar of the emails retrieving action. 
         * 
         */

        public void RetrieveMails(TextBox tbStatus, bool KeepMsgOnServer, ProgressBar pBar)
        {
            TcpClient clientSocket = new TcpClient(POP_server, 110);
            NetworkStream NetStrm = clientSocket.GetStream();
            //using (StreamReader RdStrm = new StreamReader(NetStrm)) 

            StreamReader RdStrm = new StreamReader(NetStrm);
            tbStatus.Text += RdStrm.ReadLine();
            sendPOP3cmd("USER " + POP_user + "\r\n", NetStrm, tbStatus);
            sendPOP3cmd("PASS " + POP_pass + "\r\n", NetStrm, tbStatus);
            string Data = sendPOP3cmd("STAT\r\n", NetStrm, tbStatus);
            string[] BreakDown = Data.Split(" ".ToCharArray());
            int messageCount = Convert.ToInt16(BreakDown[1]);
            pBar.Minimum = 0;
            pBar.Maximum = messageCount;
            for (int i = 1; i <= messageCount; i++)
            {
                StringBuilder message = new StringBuilder("");
                Data = "RETR " + Convert.ToString(i) + "\r\n";
                byte[] szData =
                System.Text.Encoding.ASCII.GetBytes(Data.ToCharArray());
                NetStrm.Write(szData, 0, szData.Length);
                string szTemp = RdStrm.ReadLine();
                while (szTemp != ".")
                {
                    message.Append(szTemp);
                    tbStatus.Text += szTemp + "\r\n";
                    szTemp = RdStrm.ReadLine();
                    Application.DoEvents(); 
                }
                tbStatus.Text += szTemp + "\r\n";
                if (!(KeepMsgOnServer))
                {
                   sendPOP3cmd("DELE " + Convert.ToString(i) + "\r\n", NetStrm, tbStatus);
                }
                pBar.Value = i;
                
            }
            sendPOP3cmd("QUIT\r\n", NetStrm, tbStatus);
            clientSocket.Close();
        }



        /*
         * 
         * Retrievs The First Mail On the Server - Requiers the POP setting !!
         * tbStatus - txtBox To Display Communication with the host.
         * KeepMsgOnServer - when 'true' will not delete the msg from the server.
         * pBar - Display the progress bar of the emails retrieving action. 
         * 
         */
        public void RetrieveOneMail(TextBox tbStatus, bool KeepMsgOnServer, ProgressBar pBar)
        {
            TcpClient clientSocket = new TcpClient(POP_server, 110);
            NetworkStream NetStrm = clientSocket.GetStream();
            //using (StreamReader RdStrm = new StreamReader(NetStrm)) 

            StreamReader RdStrm = new StreamReader(NetStrm);
            tbStatus.Text += RdStrm.ReadLine();
            sendPOP3cmd("USER " + POP_user + "\r\n", NetStrm, tbStatus);
            sendPOP3cmd("PASS " + POP_pass + "\r\n", NetStrm, tbStatus);
            string Data = sendPOP3cmd("STAT\r\n", NetStrm, tbStatus);
            string[] BreakDown = Data.Split(" ".ToCharArray());
            int messageCount = Convert.ToInt16(BreakDown[1]);
            pBar.Minimum = 0;
            pBar.Maximum = 5;
            if (messageCount > 0)
            {
                pBar.Value = 1;
                StringBuilder message = new StringBuilder("");
                Data = "RETR " + 1 + "\r\n";
                byte[] szData =
                System.Text.Encoding.ASCII.GetBytes(Data.ToCharArray());
                NetStrm.Write(szData, 0, szData.Length);
                string szTemp = RdStrm.ReadLine();
                pBar.Value = 2;
                while (szTemp != ".")
                {
                    message.Append(szTemp);
                    tbStatus.Text += szTemp + "\r\n";
                    szTemp = RdStrm.ReadLine();
                    Application.DoEvents();
                }
                pBar.Value = 3;
                tbStatus.Text += szTemp + "\r\n";
                if (!(KeepMsgOnServer))
                {
                    sendPOP3cmd("DELE " + Convert.ToString(1) + "\r\n", NetStrm, tbStatus);
                }
                pBar.Value = 4;

            }
            sendPOP3cmd("QUIT\r\n", NetStrm, tbStatus);
            clientSocket.Close();
            pBar.Value = 5;
        }

        /*
         * 
         * Retrievs The First Mail On the Server - Requiers the POP setting !!
         * tbStatus - txtBox To Display Communication with the host.
         * KeepMsgOnServer - when 'true' will not delete the msg from the server.
         * pBar - Display the progress bar of the emails retrieving action. 
         * 
         */
        public string RetrieveOneMailToString(TextBox tbStatus, bool KeepMsgOnServer, ProgressBar pBar)
        {
            tbStatus.Text = "";
            StringBuilder message = new StringBuilder("");
            TcpClient clientSocket = new TcpClient(POP_server, 110);
            NetworkStream NetStrm = clientSocket.GetStream();
            //using (StreamReader RdStrm = new StreamReader(NetStrm)) 
            

            StreamReader RdStrm = new StreamReader(NetStrm);
            tbStatus.Text += RdStrm.ReadLine();
            sendPOP3cmd("USER " + POP_user + "\r\n", NetStrm, tbStatus);
            sendPOP3cmd("PASS " + POP_pass + "\r\n", NetStrm, tbStatus);
            string Data = sendPOP3cmd("STAT\r\n", NetStrm, tbStatus);
            string[] BreakDown = Data.Split(" ".ToCharArray());
            int messageCount = Convert.ToInt16(BreakDown[1]);
            pBar.Minimum = 0;
            pBar.Maximum = 5;
            if (messageCount > 0)
            {
                pBar.Value = 1;
                Data = "RETR " + 1 + "\r\n";
                byte[] szData =
                System.Text.Encoding.ASCII.GetBytes(Data.ToCharArray());
                NetStrm.Write(szData, 0, szData.Length);
                string szTemp = RdStrm.ReadLine();
                pBar.Value = 2;
                while (szTemp != ".")
                {
                    message.Append(szTemp + "\r\n");
                    tbStatus.Text += szTemp + "\r\n";
                    szTemp = RdStrm.ReadLine();
                    Application.DoEvents();
                }
                pBar.Value = 3;
                tbStatus.Text += szTemp + "\r\n";
                if (!(KeepMsgOnServer))
                {
                    sendPOP3cmd("DELE " + Convert.ToString(1) + "\r\n", NetStrm, tbStatus);
                }
                pBar.Value = 4;
            }
            
            sendPOP3cmd("QUIT\r\n", NetStrm, tbStatus);
            clientSocket.Close();
            pBar.Value = 5;

            return Convert.ToString(message.Remove(0, 3));
        }




        /*
         * Send Email Using the SMTP Server Setting
         * Needs the "SetSMTP" To be Excecuted Before.
         * To - Can be more then one email, each mail separated by ;
         * From - Must be in email format, and some Server are checking it to be the account user.
         * DisplayName - the name to be displayed in the outlook.
         * Subject - String until 256 chars.
         * Message - String
         */ 
        public void SendMail(string To, string From, string DisplayName, string Sbj, string Msg)
        {
            // NEED TO ADD
            // Validate Input !!!, and  CC, BCC.

            //Create MailMessage Object
            MailMessage email_msg = new MailMessage();

            //Specifying From,Sender & Reply to address
            email_msg.From = new MailAddress(From, DisplayName);
            email_msg.Sender = new MailAddress(From, DisplayName);
            email_msg.ReplyTo = new MailAddress(From, DisplayName);

            //The To Email id
            email_msg.To.Add(To);

            email_msg.Subject = Sbj;//Subject of email
            email_msg.Body = Msg;
            email_msg.Priority = MailPriority.High;

           //Create an object for SmtpClient class
            SmtpClient mail_client = new SmtpClient();

            //Providing Credentials (Username & password)
            NetworkCredential network_cdr = new NetworkCredential();
            network_cdr.UserName = SMTP_user;
            network_cdr.Password = SMTP_pass;
            mail_client.UseDefaultCredentials = false;
            mail_client.Credentials = network_cdr;

            //SMTP Server
            mail_client.Host = SMTP_server;

            //Send the message
            mail_client.Send(email_msg);
            MessageBox.Show("Mail Sent.", "-=Mail Sent=-", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }// SendMail


        /*
         * isEmail Function
         * Varify that a certine string is a valid email affress or not.
         * 
         * if input is empty then returns false.
         * 
         */
        public static bool isEmail(string inputEmail)
        {
            if (inputEmail == null || inputEmail.Length == 0)
            {
                throw new ArgumentNullException("inputEmail");
            }

            const string expression = @"^([a-zA-Z0-9_\-\.]+)@((\[[0-9]{1,3}" +
                                      @"\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\" +
                                      @".)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$";

            Regex regex = new Regex(expression);
            return regex.IsMatch(inputEmail);
        }//is eMail


        /*
         * EmailHeadersGetSubject
         * The Function extracte the email's Subject.
         */
        public string EmailHeadersGetSubject(string EmailString)
        {
            return Regex.Matches(EmailString, "Subject: (.+)")[0].ToString();
        }

        /*
         * EmailHeadersGetSubject
         * The Function extracte the email's From Field.
         */
        public string EmailHeadersGetFrom(string EmailString)
        {
            return Regex.Matches(EmailString, "From: (.+)")[0].ToString();
        }

        /*
         * EmailHeadersGetSubject
         * The Function extracte the email's To Field.
         */
        public string EmailHeadersGetTo(string EmailString)
        {
            return Regex.Matches(EmailString, "To: (.+)")[0].ToString();
        }
    
    }// Mail Handler
}
